10 rem Program for calculating relaxation oscillation in random laser pumped by a flashlamp using gaussian shaped pulses 
20 rem tao - luminescence decay-time (s)
30 tao = 1.600000E-05
40 rem tres - residence time for the photon in the pumped volume (s)
50 tres = 1.000000E-11
60 rem sigma - maximum emission cross section (cm^2)
70 s = 9.000000E-20
80 rem lpump-pumping wavelength(nm)
90 lpump = 532
100 rem lem - emission wavelength(nm)
110 lem = 1063
120 rem Kabssol - absorption coefficient in solid (cm-1)
130 kabssol = 12.5
140 rem Y - filling factor
150 y = 0
160 rem kabs-absorption coefficient in mixture
170 kabs = kabssol*(1-y)
180 rem c - speed of light (cm/s)
190 c = 30000000000
200 rem nupump - frequency of pumping (Hz)
210 nupump = c/lpump/1.000000E-07
220 rem nuem - frequency of emission (Hz)
230 nuem = c/lem/1.000000E-07
240 rem h - Plank constant (erg*s)
250 h = 6.600000E-34
260 rem peakpump-peak pumping power
270 peakpump = 1000000000
280 rem dt0 - time step in calculation (s)
290 dt0 = 2.000000E-12
300 rem dt1 - time step between points in K(x) and E(x) arrays
310 dt1 = 1.500000E-10
320 rem x-number of points in the pulse shape array
330 tmax = 1.500000E-08
340 rem twidth- duration of gaussian pulse
350 twidth = 5.000000E-09
360 x = 200
370 rem tmax-time of pump max
380 rem kp(x)-array for the pulse shape, e(x)-array for stim. emission, n(x)-array for population inversion
390 dim kp(x)
400 dim e(x)
410 dim n(x)
420 rem ************************************************
430 rem dn - dn/dt, n0 - current population inversion, dem - d(emo)/dt0
440 n0 = 0
450 rem - em0-current 1.06 emmission
460 em0 = 0
470 rem starting conditions for e(x) and n(x)
480 e(1) = 0
490 n(1) = 0
500 rem - emax - maximum of emission, em0max-max emission value within dt1, kpmax-max of pump, nmax-max of population
510 emax = 0
520 rem em0max = 0
530 kpmax = 0
540 nmax = 0
550 rem peakpump- peak pumping power
560 rem THE MAIN LOOP
570 for k = 1 to x-1
575 rem print "k=",k
580 for j = 1 to dt1/dt0
585 rem t=current time
586 t = (j-1)*dt0+(k-1)*dt1
587 rem p - pumping power
588 p = peakpump*exp((-1)*(t-tmax)^2/twidth^2)
600 dn = p*kabs/h/nupump-(n0/tao)-(em0*c*s*n0/h/nuem)
620 n0 = n0+dn*dt0
630 dem = -em0/tres+(16/118*n0*(1/tao)*h*nuem)+(em0*c*s*n0)
650 em0 = em0+dem*dt0
670 next j
680 e(k) = em0
720 kp(k) = p
725 rem Ep- total pumping energy density (J/cm^2)
730 n(k) = n0
740 next k
790 for k = 1 to x
800 if e(k) > emax then emax = e(k)
810 if kp(k) > kpmax then kpmax = kp(k)
811 ep = ep+kp(k)*dt1
820 if n(k) > nmax then nmax = n(k)
830 next k
841 print "Ep =",ep
850 rem elastmax-max values of e in last 150 points, elastmin-min value of e in last 50 points
920 graphics window 300,300
930 graphics 0
940 moveto 0,200
950 for i = 1 to x
960 lineto i,(200*(1-e(i)/emax))
970 next i
980 graphics color 100,0,0
990 moveto 0,200
1000 for i = 1 to x
1010 lineto i,(1-kp(i)/kpmax)*200
1020 next i
1030 moveto 0,200
1040 graphics color 0,0,100
1050 for i = 1 to x
1060 lineto i,200*(1-n(i)/nmax)
1070 next i
1080 open "simulation" for output as #1
1090 print #1,"calculation of random laser pulses under long gaussian pumping"
1120 print #1,"tao=",tao,"tres=",tres,"s=",s,"lpump=",lpump
1130 print #1,"lem=",lem,"kabssol=",kabssol,"y=",y,"ppump=",ppump
1140 print #1,"tmax=",tmax,"twidth=",twidth,"dt0=",dt0,"dt1=",dt1
1150 print #1,"peakpump =",peakpump,"Ep =",ep
1160 print #1,"t","pumping","emission","n","emax="
1170 for i = 1 to x
1180 print #1,dt1*i,kp(i),e(i),n(i)
1190 next i
1200 close #1
